<template>
  <div class="d-textarea">
    <label :class="[exceed ? 'in-error' : '']" v-html="getTitle" />
    <vs-textarea
      v-model="value"
      :counter="maxLetters"
      :counter-danger.sync="exceed"
      :class="['w-full', classes, exceed ? 'in-error-border' : '']"
      name="d-textarea"
      @input="updateInput"
    />
  </div>
</template>

<script>
export default {
  props: {
    disabled: {
      required: false,
      type: Boolean,
      default: false
    },
    label: {
      required: false,
      type: String,
      default: "&nbsp"
    },
    maxLetters: {
      // use v-validation rules string
      required: false,
      type: Number,
      default: null
    },
    value: {
      required: false,
      type: [Object, String, Number],
      default: ""
    },
    styles: {
      required: false,
      type: String,
      default: ""
    },
    classes: {
      required: false,
      type: String,
      default: ""
    },
    required: {
      required: false,
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      exceed: false
    };
  },
  computed: {
    getTitle() {
      let append = "";
      if (this.required) {
        append = " *";
      }
      return `${this.label}${append}`;
    }
  },
  methods: {
    updateInput() {
      this.$emit("input", this.value);
    }
  }
};
</script>

<style lang="scss">
@import "@/assets/scss/vuexy/_variables.scss";

.d-textarea {
  // .vs-input-primary .vs-input--input:focus {
  // 	border-color: $d-input-focus-color !important;
  // }
  label {
    font-size: $d-input-label-size;
    padding-left: $d-input-label-padding;
  }

  .in-error {
    color: red !important;
  }

  .in-error-border {
    border-color: red !important;
  }
}
</style>
